// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `file0.ice'

#include <file0.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

void
IceInternal::incRef(::MA::A* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::MA::A* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::MA::A* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::MA::A* p)
{
    p->__decRef();
}

void
MA::__write(::IceInternal::BasicStream* __os, const ::MA::APrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
MA::__read(::IceInternal::BasicStream* __is, ::MA::APrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::MA::A;
	v->__copyFrom(proxy);
    }
}

void
MA::__write(::IceInternal::BasicStream* __os, const ::MA::APtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

::MB::B
IceProxy::MA::A::GetB()
{
    return GetB(__defaultContext());
}

::MB::B
IceProxy::MA::A::GetB(const ::Ice::Context& __ctx)
{
    int __cnt = 0;
    while(true)
    {
	try
	{
	    __checkTwowayOnly("GetB");
	    ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase = __getDelegate();
	    ::IceDelegate::MA::A* __del = dynamic_cast< ::IceDelegate::MA::A*>(__delBase.get());
	    return __del->GetB(__ctx);
	}
	catch(const ::IceInternal::NonRepeatable& __ex)
	{
	    __rethrowException(*__ex.get());
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    __handleException(__ex, __cnt);
	}
    }
}

const ::std::string&
IceProxy::MA::A::ice_staticId()
{
    return ::MA::A::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::MA::A::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::MA::A);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::MA::A::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::MA::A);
}

bool
IceProxy::MA::operator==(const ::IceProxy::MA::A& l, const ::IceProxy::MA::A& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::MA::operator!=(const ::IceProxy::MA::A& l, const ::IceProxy::MA::A& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::MA::operator<(const ::IceProxy::MA::A& l, const ::IceProxy::MA::A& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

static const ::std::string __MA__A__GetB_name = "GetB";

::MB::B
IceDelegateM::MA::A::GetB(const ::Ice::Context& __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __MA__A__GetB_name, static_cast< ::Ice::OperationMode>(0), __context, __compress);
    bool __ok = __og.invoke();
    try
    {
	::IceInternal::BasicStream* __is = __og.is();
	if(!__ok)
	{
	    __is->throwException();
	}
	::MB::B __ret;
	__ret.__read(__is);
	return __ret;
    }
    catch(const ::Ice::UserException&)
    {
	throw ::Ice::UnknownUserException(__FILE__, __LINE__);
    }
    catch(const ::Ice::LocalException& __ex)
    {
	throw ::IceInternal::NonRepeatable(__ex);
    }
}

::MB::B
IceDelegateD::MA::A::GetB(const ::Ice::Context& __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, "GetB", static_cast< ::Ice::OperationMode>(0), __context);
    while(true)
    {
	::IceInternal::Direct __direct(__current);
	::MA::A* __servant = dynamic_cast< ::MA::A*>(__direct.servant().get());
	if(!__servant)
	{
	    ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
	    __opEx.id = __current.id;
	    __opEx.facet = __current.facet;
	    __opEx.operation = __current.operation;
	    throw __opEx;
	}
	try
	{
	    return __servant->GetB(__current);
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    throw ::IceInternal::NonRepeatable(__ex);
	}
    }
}

static const ::std::string __MA__A_ids[2] =
{
    "::Ice::Object",
    "::MA::A"
};

bool
MA::A::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__MA__A_ids, __MA__A_ids + 2, _s);
}

::std::vector< ::std::string>
MA::A::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__MA__A_ids[0], &__MA__A_ids[2]);
}

const ::std::string&
MA::A::ice_id(const ::Ice::Current&) const
{
    return __MA__A_ids[1];
}

const ::std::string&
MA::A::ice_staticId()
{
    return __MA__A_ids[1];
}

::IceInternal::DispatchStatus
MA::A::___GetB(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    ::IceInternal::BasicStream* __os = __inS.os();
    ::MB::B __ret = GetB(__current);
    __ret.__write(__os);
    return ::IceInternal::DispatchOK;
}

static ::std::string __MA__A_all[] =
{
    "GetB",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
MA::A::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__MA__A_all, __MA__A_all + 5, current.operation);
    if(r.first == r.second)
    {
	return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __MA__A_all)
    {
	case 0:
	{
	    return ___GetB(in, current);
	}
	case 1:
	{
	    return ___ice_id(in, current);
	}
	case 2:
	{
	    return ___ice_ids(in, current);
	}
	case 3:
	{
	    return ___ice_isA(in, current);
	}
	case 4:
	{
	    return ___ice_ping(in, current);
	}
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
MA::A::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
MA::A::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
MA::A::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type MA::A was not generated with stream support";
    throw ex;
}

void
MA::A::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type MA::A was not generated with stream support";
    throw ex;
}

void 
MA::__patch__APtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::MA::APtr* p = static_cast< ::MA::APtr*>(__addr);
    assert(p);
    *p = ::MA::APtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::MA::A::ice_staticId();
	throw e;
    }
}

bool
MA::operator==(const ::MA::A& l, const ::MA::A& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
MA::operator!=(const ::MA::A& l, const ::MA::A& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
MA::operator<(const ::MA::A& l, const ::MA::A& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
