// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `file1.ice'

#include <file1.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

bool
MB::B::operator==(const B& __rhs) const
{
    return !operator!=(__rhs);
}

bool
MB::B::operator!=(const B& __rhs) const
{
    if(this == &__rhs)
    {
	return false;
    }
    if(SomeValue != __rhs.SomeValue)
    {
	return true;
    }
    return false;
}

bool
MB::B::operator<(const B& __rhs) const
{
    if(this == &__rhs)
    {
	return false;
    }
    if(SomeValue < __rhs.SomeValue)
    {
	return true;
    }
    else if(__rhs.SomeValue < SomeValue)
    {
	return false;
    }
    return false;
}

void
MB::B::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(SomeValue);
}

void
MB::B::__read(::IceInternal::BasicStream* __is)
{
    __is->read(SomeValue);
}
